part of babylon;

/// class BaseTexture
@JS()
class BaseTexture extends ThinTexture implements IAnimatable {
  external BaseTexture();
  external BaseTexture.args(dynamic sceneOrEngine);
  external bool get hasAlpha;
  external num get coordinatesMode;
  external num get wrapU;
  external num get wrapV;
  external bool get isCube;
  external bool get is3D;
  external bool get is2DArray;
  external bool get gammaSpace;
  external bool get isRGBD;
  external bool get noMipmap;
  external num get lodGenerationOffset;
  external num get lodGenerationScale;
  external bool get linearSpecularLOD;
  external BaseTexture get irradianceTexture;
  external String get uid;
  external bool get isBlocking;
  external bool get canRescale;
  external num get textureType;
  external num get textureFormat;
  external static num get DEFAULT_ANISOTROPIC_FILTERING_LEVEL;
  external num get uniqueId;
  external String get name;
  external dynamic get metadata;
  external dynamic get reservedDataStore;
  external bool get getAlphaFromRGB;
  external num get level;
  external num get coordinatesIndex;
  external num get wrapR;
  external num get anisotropicFilteringLevel;
  external bool get invertZ;
  external bool get lodLevelInAlpha;
  external bool get isRenderTarget;
  external List<Animation> get animations;
  external Observable<BaseTexture> get onDisposeObservable;
  external set hasAlpha(bool value);
  external set coordinatesMode(num value);
  external set wrapU(num value);
  external set wrapV(num value);
  external set isCube(bool value);
  external set is3D(bool value);
  external set is2DArray(bool value);
  external set gammaSpace(bool gamma);
  external set isRGBD(bool value);
  external set lodGenerationOffset(num value);
  external set lodGenerationScale(num value);
  external set linearSpecularLOD(bool value);
  external set irradianceTexture(BaseTexture value);
  external set onDispose(void Function() callback);
  external static set DEFAULT_ANISOTROPIC_FILTERING_LEVEL(num DEFAULT_ANISOTROPIC_FILTERING_LEVEL);
  external set uniqueId(num uniqueId);
  external set name(String name);
  external set metadata(dynamic metadata);
  external set reservedDataStore(dynamic reservedDataStore);
  external set getAlphaFromRGB(bool getAlphaFromRGB);
  external set level(num level);
  external set coordinatesIndex(num coordinatesIndex);
  external set wrapR(num wrapR);
  external set anisotropicFilteringLevel(num anisotropicFilteringLevel);
  external set invertZ(bool invertZ);
  external set lodLevelInAlpha(bool lodLevelInAlpha);
  external set isRenderTarget(bool isRenderTarget);
  external set animations(List<Animation> animations);
  external set onDisposeObservable(Observable<BaseTexture> onDisposeObservable);
  external String toString();
  external String getClassName();
  external Scene getScene();
  external bool checkTransformsAreIdentical(BaseTexture texture);
  external Matrix getTextureMatrix();
  external Matrix getReflectionTextureMatrix();
  external bool isReadyOrNotBlocking();
  external void scale(num ratio);
  external BaseTexture clone();
  external List readPixels([num faceIndex, num level, List buffer]);
  external void dispose();
  external dynamic serialize();
  external static void WhenAllReady(List<BaseTexture> textures, void Function() callback);
  external SphericalPolynomial sphericalPolynomial;
}
